/*
						@Ђ_̐E

						1994/12/09  --------
*/


#include <conio.h>
#include <dos.h>
#include <graphics.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

const double PI = 3.141592653589793;
#define abs(val) ((val >= 0) ? val : -val)


const double magnification = 250;			/*	{iP^j	*/


struct Point3D {
	double x, y, z;							/*	̂̍W	*/
};

struct PointScreen {
	int x, y;								/*	ʂ̍W	*/
};

typedef struct Point3D P3D;
typedef struct PointScreen ScrP;


/*	[JW𐢊EWɕϊ	*/
P3D Local2World(P3D V, P3D W, double theta, double phi, double rho)
{
	P3D A;									/*	̌vZp	*/

	/*	x𒆐S theta (ި) ]	*/
	A.x = V.x * cos(theta) - V.z * sin(theta);
	A.y = V.y;
	A.z = V.z * cos(theta) + V.x * sin(theta);

	/*	w𒆐S phi (ި) ]	*/
	V = A;
	A.x = V.x;
	A.y = V.y * cos(phi) - V.z * sin(phi);
	A.z = V.z * cos(phi) + V.y * sin(phi);

	/*	y𒆐S rho (ި) ]	*/
	V = A;
	A.x = V.x * cos(rho) - V.y * sin(rho);
	A.y = V.y * cos(rho) + V.x * sin(rho);
	A.z = V.z;

	/*	EWɕϊ	*/
	A.x += W.x;
	A.y += W.y;
	A.z += W.z;

	return A;

}


/*	EW[JWɕϊ	*/
P3D World2Local(P3D W, P3D V, double theta, double phi, double rho)
{
	P3D A;									/*	̌vZp	*/

	/*	[JWɕϊ	*/
	W.x -= V.x;
	W.y -= V.y;
	W.z -= V.z;

	/*	x𒆐S -theta (ި) ]	*/
	A.x = W.x * cos(-theta) - W.z * sin(-theta);
	A.y = W.y;
	A.z = W.z * cos(-theta) + W.x * sin(-theta);

	/*	w𒆐S -phi (ި) ]	*/
	W = A;
	A.x = W.x;
	A.y = W.y * cos(-phi) - W.z * sin(-phi);
	A.z = W.z * cos(-phi) + W.y * sin(-phi);

	/*	y𒆐S -rho (ި) ]	*/
	W = A;
	A.x = W.x * cos(-rho) - W.y * sin(-rho);
	A.y = W.y * cos(-rho) + W.x * sin(-rho);
	A.z = W.z;

	return A;
}


/*	̂̍W𕽖ʂ̍Wɕϊ	*/
ScrP ProjectView(P3D V)
{
	ScrP W;
	if (abs(V.z) > 0.001) {
		W.x = getmaxx() / 2 + (magnification * V.x / V.z);
		W.y = getmaxy() / 2 - (magnification * V.y / V.z);
	}
	else {
		/*	ǂ悤EEE(ȏ)Y	*/
		W.x = getmaxx() / 2 + (magnification * V.x / 0.0001);
		W.y = getmaxy() / 2 - (magnification * V.y / 0.0001);
	}

	return W;
}



class GWorld;


class GObj {
protected:
	GWorld *world;
	P3D    W;						/*	zEɑ΂W	*/
	double theta;					/*	cɉ񂷊px			*/
	double phi;						/*	ɉ񂷊px			*/
	double rho;						/*	ɉ񂷊px			*/
	int color;						/*	IuWFNg̐F		*/
	int DrowFlag;					/*	ݕ`Ă邩H	*/
public:
	GObj(double x = 0, double y = 0, double z = 0,
							double T = 0, double P = 0, double R = 0) {
		W.x = x;
		W.y = y;
		W.z = z;
		theta = T;
		phi = P;
		rho = R;
		color = WHITE;
		world = NULL;
		DrowFlag = 0;
	}
	virtual void Drow_(void) {}
	void Drow(void) { setcolor(color); Drow_(); DrowFlag = 1; }
	void Erase(void) { setcolor(BLACK); Drow_(); DrowFlag = 0; }
	double GetX(void) { return W.x; }
	double GetY(void) { return W.y; }
	double GetZ(void) { return W.z; }
	double GetTheta(void) { return theta; }
	double GetPhi(void) { return phi; }
	double GetRho(void) { return rho; }
	double SetTheta(double T);
	double SetPhi(double P);
	double SetRho(double R);
	void Turn(double T, double P, double R);
	void LocalTurn(double T, double P, double R);
	void MoveTo(P3D w) { MoveTo(w.x, w.y, w.z); }
	void MoveTo(double x, double y, double z);
	void Go(double x, double y, double z);
	int GetColor(void) { return color; }
	int SetColor(int C) {
		color = C;
		MoveTo(W);
		return color;
	}
	void SetWorld(GWorld *w) { world = w; }
	void Line_(P3D S, P3D E);
};


class GMaster : public GObj {
	int WorldViewFlag;			/*	E݂Ă邩H	*/
public:
	GMaster(double x = 0, double y = 0, double z = 0,
								double T = 0, double P = 0, double R = 0)
										: GObj(x, y, z, T, P, R) {
				WorldViewFlag = 0;
	}
	void Line(P3D WS, P3D WE);
	void WorldView(void);
	void UnWorldView(void) { clearviewport(); WorldViewFlag = 0; }
	double SetTheta(double T);
	double SetPhi(double P);
	double SetRho(double R);
	void Turn(double T, double P, double R);
	void LocalTurn(double T, double P, double R);
	void MoveTo(double x, double y, double z);
	void Go(double x, double y, double z);
};


struct GObjList {
	GObj *obj;						/*	ێIuWFNg	*/
	GObjList *next;					/*	̃Xgւ̃|C^	*/
};


class GWorld {
	GMaster *master;			/*	̐E̎l					*/
	GObjList *start;			/*	̐Eɂ̂̃Xgi擪j	*/
	GObjList *end;				/*	̐Eɂ̂̃XgiI[j	*/
public:
	GWorld(GMaster *m = NULL) {
		SetMaster(m);
		start = end = NULL;
	}
	void Line(P3D S, P3D E) { master->Line(S, E); }
	void GetIn(GObj *o);
	void GObjDrow(void);
	void GObjErase(void);
	void SetMaster(GMaster *m) { master = m; }
	GMaster *GetMaster(void) { return master; }
};


class Human : public GMaster {
public:
	Human(double x = 0, double y = 0, double z = 0,
								double T = 0, double P = 0, double R = 0)
		: GMaster(x, y, z, T, P, R) {}
	void Drow_(void);
};


/*	theta ݒ	*/
double GObj::SetTheta(double T)
{
	int work = DrowFlag;
	if (work)
		Erase();
	theta = T;
	if (work)
		Drow();
	return theta;
}


/*	phi ݒ	*/
double GObj::SetPhi(double P)
{
	int work = DrowFlag;
	if (work)
		Erase();

	phi = P;

	if (work)
		Drow();
	return phi;
}

double GObj::SetRho(double R)
{
	int work = DrowFlag;
	if (work)
		Erase();

	rho = R;

	if (work)
		Drow();
	return rho;
}


/*	݂̊px]	*/
void GObj::Turn(double T, double P, double R)
{
	int work = DrowFlag;
	if (work != 0)
		Erase();

	theta += T;
	phi += P;
	rho += R;

	if (work)
		Drow();
}


/*	݂̊px瑊ΓIɉ]	*/
void GObj::LocalTurn(double T, double P, double R)
{
	int work = DrowFlag;
	if (work != 0)
		Erase();

	P3D S, Dmy;

	S.x = P;
	S.y = T;
	S.z = R;
	Dmy.x = 0;
	Dmy.y = 0;
	Dmy.z = 0;

	S = Local2World(S, Dmy, theta, phi, rho);

	theta += S.y;
	phi += S.x;
	rho += S.z;

	if (work)
		Drow();
}


/*	̒n_Ɉړ	*/
void GObj::MoveTo(double x, double y, double z)
{
	int work = DrowFlag;
	if (work)
		Erase();

	W.x = x;
	W.y = y;
	W.z = z;

	if (work)
		Drow();
}


/*	pxlȂ瑊ΓIɈړ	*/
void GObj::Go(double x, double y, double z)
{
	int work = DrowFlag;
	if (work)
		Erase();

	P3D S, Dmy;

	S.x = x;
	S.y = y;
	S.z = z;
	Dmy.x = 0;
	Dmy.y = 0;
	Dmy.z = 0;

	S = World2Local(S, Dmy, -theta, -phi, -rho);

	W.x += S.x;
	W.y += S.y;
	W.z += S.z;

	if (work)
		Drow();
}


/*	EɐЂ	*/
void GObj::Line_(P3D S, P3D E)
{
	if (world) {
		P3D WS, WE;
		WS = Local2World(S, W, theta, phi, rho);
		WE = Local2World(E, W, theta, phi, rho);
		world->Line(WS, WE);
	}
}



/*	Eɓ	*/
void GWorld::GetIn(GObj *o)
{
	if (end == NULL) {
		start = end = new GObjList;
		if (start == NULL)
			abort();
		start->obj = o;
		start->next = NULL;
	}
	else {
		end->next = new GObjList;
		if (end->next == NULL)
			abort();
		end = end->next;
		end->obj = o;
		end->next = NULL;
	}
	o->SetWorld(this);
}


/*	ȆSẴIuWFNg\	*/
void GWorld::GObjDrow(void)
{
	GObjList *obj = start;
	while (obj) {
		obj->obj->Drow();
		obj = obj->next;
	}
}


/*	ȆSẴIuWFNg	*/
void GWorld::GObjErase(void)
{
	GObjList *obj = start;
	while (obj) {
		obj->obj->Erase();
		obj = obj->next;
	}
}


/*	E	*/
void GMaster::WorldView(void)
{
	if (world) {
		world->GObjDrow();
		WorldViewFlag = 1;
	}
}


/*	EɐЂ	*/
void GMaster::Line(P3D WS, P3D WE)
{
	P3D PLarge, PSmall;
	PLarge = World2Local(WS, W, theta, phi, rho);
	PSmall = World2Local(WE, W, theta, phi, rho);

	if (PLarge.z < PSmall.z) {
		P3D Work;
		Work = PLarge;
		PLarge = PSmall;
		PSmall = Work;
	}
	if (PLarge.z < 0.01)
		return;
	else if (!(PSmall.z > 0.01)) {
		/*	ǂ炩 z W 0.01 ȉ̏	*/
		PSmall.x += (PLarge.x - PSmall.x) * PSmall.z / (PLarge.z - PSmall.z);
		PSmall.y += (PLarge.y - PSmall.y) * PSmall.z / (PLarge.z - PSmall.z);
		PSmall.z = 0.01;
	}

	ScrP SS, SE;
	SS = ProjectView(PSmall);
	SE = ProjectView(PLarge);
	::line(SS.x, SS.y, SE.x, SE.y);
}


double GMaster::SetTheta(double T)
{
	if (world->GetMaster() == this) {
		int work = WorldViewFlag;
		if (work)
			UnWorldView();
		theta = T;
		if (work)
			WorldView();
		return theta;
	}
	else
		return GObj::SetTheta(T);
}


double GMaster::SetPhi(double P)
{
	if (world->GetMaster() == this) {
		int work = WorldViewFlag;
		if (work)
			UnWorldView();
		phi = P;
		if (work)
			WorldView();
		return phi;
	}
	else
		return GObj::SetPhi(P);
}

double GMaster::SetRho(double R)
{
	if (world->GetMaster() == this) {
		int work = WorldViewFlag;
		if (work)
			UnWorldView();
		rho = R;
		if (work)
			WorldView();
		return rho;
	}
	else
		return GObj::SetRho(R);
}


void GMaster::Turn(double T, double P, double R)
{
	if (world->GetMaster() == this) {
		int work = WorldViewFlag;
		if (work)
			UnWorldView();

		theta += T;
		phi += P;
		rho += R;

		if (work)
			WorldView();
	}
	else
		GObj::Turn(T, P, R);
}


/*	݂̊px瑊ΓIɉ]	*/
void GMaster::LocalTurn(double T, double P, double R)
{
	if (world->GetMaster() == this) {
	    int work = WorldViewFlag;
	    if (work != 0)
		    UnWorldView();

	    P3D S, Dmy;

	    S.x = P;
	    S.y = T;
	    S.z = R;
	    Dmy.x = 0;
	    Dmy.y = 0;
	    Dmy.z = 0;

		S = Local2World(S, Dmy, -phi, -theta, -rho);

	    theta += S.y;
	    phi += S.x;
	    rho += S.z;

	    if (work)
		    WorldView();
    }
    else
		GObj::LocalTurn(T, P, R);
}

void GMaster::MoveTo(double x, double y, double z)
{
	if (world->GetMaster() == this) {
		int work = WorldViewFlag;
		if (work)
			UnWorldView();

		W.x = x;
		W.y = y;
		W.z = z;

		if (work)
			WorldView();
	}
	else
		GObj::MoveTo(x, y, z);
}


void GMaster::Go(double x, double y, double z)
{
	if (world->GetMaster() == this) {
		int work = WorldViewFlag;
		if (work)
			UnWorldView();

		P3D S, Dmy;

		S.x = x;
		S.y = y;
		S.z = z;
		Dmy.x = 0;
		Dmy.y = 0;
		Dmy.z = 0;

		S = World2Local(S, Dmy, -theta, -phi, -rho);

		W.x += S.x;
		W.y += S.y;
		W.z += S.z;

		if (work)
			WorldView();
	}
	else
		GObj::Go(x, y, z);
}



/*	ľ``	*/
void Human::Drow_(void)
{
	P3D p[] = {
		{  0.0,  0.0,  0.0 },
		{ -1.0, -1.0,  0.0 },
		{  1.0, -1.0,  0.0 },
		{ -1.0, -3.5,  0.0 },
		{  1.0, -3.5,  0.0 },
		{  0.0, -3.5,  0.0 },
		{ -1.0, -6.0,  0.0 },
		{  1.0, -6.0,  0.0 },
		{  0.0, -0.5,  0.0 },
		{  0.0, -0.5,  0.35 }
	};
	Line_(p[0], p[5]);
	Line_(p[1], p[2]);
	Line_(p[1], p[3]);
	Line_(p[2], p[4]);
	Line_(p[5], p[6]);
	Line_(p[5], p[7]);
	Line_(p[8], p[9]);
}




class Plane : public GMaster {
public:
	Plane(double x = 0, double y = 0, double z = 0,
								double T = 0, double P = 0, double R = 0)
		: GMaster(x, y, z, T, P, R) {}
	void Drow_(void);
};



/*	s@̌``	*/
void Plane::Drow_(void)
{
	P3D p[] = {
		{  0.0,  0.0,  0.0 },	/*		*/
		{  0.0, -1.0,  1.0 },
		{  0.0, -1.0, -9.0 },
		{  0.0,  2.0, -9.0 },
		{  0.0,  2.0, -8.0 },
		{  0.0,  0.8, -7.0 },

		{  0.0, -1.0, -3.0 },	/*	嗃	*/
		{  0.0, -1.0, -5.0 },
		{  7.0, -0.5, -4.0 },
		{  7.0, -0.5, -5.0 },
		{ -7.0, -0.5, -4.0 },
		{ -7.0, -0.5, -5.0 },

		{  0.0,  2.0, -8.0 },	/*		*/
		{  2.0,  2.0, -8.5 },
		{  2.0,  2.0, -9.0 },
		{ -2.0,  2.0, -9.0 },
		{ -2.0,  2.0, -8.5 }
	};
    int c = getcolor();
    if (c)
	    setcolor(RED);
	Line_(p[0], p[1]);
    setcolor(c);
	Line_(p[1], p[2]);
	Line_(p[2], p[3]);
	Line_(p[3], p[4]);
	Line_(p[4], p[5]);
    c = getcolor();
    if (c)
	    setcolor(BROWN);
	Line_(p[5], p[0]);
    setcolor(c);

	Line_(p[6], p[8]);
	Line_(p[8], p[9]);
	Line_(p[9], p[7]);
	Line_(p[6], p[10]);
	Line_(p[10], p[11]);
	Line_(p[11], p[7]);

	Line_(p[12], p[13]);
	Line_(p[13], p[14]);
	Line_(p[14], p[15]);
	Line_(p[15], p[16]);
	Line_(p[16], p[12]);
}



void main(void)
{
	/* ov */
	static int gdriver = DETECT, gmode, errorcode;

	/* OtBbNXVXȅ */
	initgraph(&gdriver, &gmode, "c:\\tc\\bgi");

	/* ̌ʂ擾 */
	errorcode = graphresult();
	if (errorcode != grOk)  /* G[H */
	{
	   printf("Graphics error: %s\n", grapherrormsg(errorcode));
	   printf("Press any key to halt:");
	   getch();
	   exit(1); /* G[ƂďI */
	}

	setbkcolor(BLUE);

	Human matsubara(0, 0, 0);
	Human kobayashi(0, 0, 20);
	Human toyohuku(10, 0, 40, PI / 3);
	Plane P1(0, 0, 50, PI / 2);
	GWorld TccWorld;


	TccWorld.GetIn(&matsubara);
	TccWorld.GetIn(&kobayashi);
	TccWorld.GetIn(&toyohuku);
	TccWorld.GetIn(&P1);

	TccWorld.SetMaster(&matsubara);
//	TccWorld.SetMaster(&P1);

	kobayashi.SetColor(YELLOW);
	toyohuku.SetColor(RED);
	TccWorld.GetMaster()->WorldView();
	int c;
	while ((c = getch()) != '.') {
		switch (c) {
		case '4':
			matsubara.Turn(0.1, 0, 0);
			break;
		case '6':
			matsubara.Turn(-0.1, 0, 0);
			break;
		case '8':
			matsubara.Go(0, 0, 1);
			break;
		case '2':
			matsubara.Go(0, 0, -1);
			break;

		case 's':
		case 'S':
			kobayashi.Turn(0.1, 0, 0);
			break;
		case 'd':
		case 'D':
			kobayashi.Turn(-0.1, 0, 0);
			break;
		case 'e':
		case 'E':
			kobayashi.Go(0, 0, 1);
			break;
		case 'x':
		case 'X':
			kobayashi.Go(0, 0, -1);
			break;

		case 'f':
		case 'F':
			toyohuku.Turn(0.1, 0, 0);
			break;
		case 'g':
		case 'G':
			toyohuku.Turn(-0.1, 0, 0);
			break;
		case 't':
		case 'T':
			toyohuku.Go(0, 0, 1);
			break;
		case 'v':
		case 'V':
			toyohuku.Go(0, 0, -1);
			break;

		case 'h':
		case 'H':
			P1.LocalTurn(PI / 8, 0, 0);
			break;
		case 'j':
		case 'J':
			P1.LocalTurn(-PI / 8, 0, 0);
			break;
		case 'u':
		case 'U':
			P1.LocalTurn(0, PI / 8, 0);
			break;
		case 'n':
		case 'N':
			P1.LocalTurn(0, -PI / 8, 0);
			break;
		case ' ':
			P1.Go(0, 0, 10);
			break;
		}
	}
	setbkcolor(BLACK);
	closegraph();
}


